#ifndef CENTRALUI_H
#define CENTRALUI_H


#include <string>
#include <vector>

using namespace std;

#include <qobject.h>
#include <qtimer.h>
#include "QtWindow\window3\SummaryWidget.h"
#include "SoftProj\reviewTables.h"
//#include "apps\AppSoftProj.h"

using namespace SoftProject;


class CentralUI: public QObject
{
	Q_OBJECT

private:
	static const int RENDER_INTERVAL;
	QTimer renderTimer;

	SoftProj &softProj;

	CentralInfo centralInfo;
	NavigationComputer navigationComputer;
	QuarkGluonKernel quarkGluonKernel;
	SubspaceBeacon subspaceBeacon;
	IntertialDamper inertialDamper;


public:
	CentralUI( SoftProj &softProj, SummaryTable& dstTable,  QWidget *parent = 0 );

private slots:
	void refreshRenderSlot( void );

public slots:
	void setCentralInfo(void);		/**< Activate centralInfo table */
	void setSubspaceDrive(void);	/**< Activate subspaceDrive table */
};

#endif
