#ifndef SOFTPROJRENDER_H
#define SOFTPROJRENDER_H

#include "./../../lib/GLee/GLee.h"	
 #include <QGLContext>
#include "./renderer/GLphongRender.h"

#include "./illumination/tricol.h"
#include <iterator>

#include "./math/Mathematics.h"
using namespace ANALYTICAL_GEOMETRY;
using namespace GEOMETRY;

///Render class used for SoftProj game.
/**
*	Class is based on GLPhongRender class, but extends its functionality with some new graphic primitives.
*/
class SoftProjRender: public GLPhongRender
{
public:
	SoftProjRender( Context &context, CGprogram vertexShader, CGprogram fragmentShader );  /**<  context = informace kam renderovat, vertexShader a fragmentShader = se tridou kompatibilni shadery, shadowTextur =ID textury urcene pro shadow mapping, shadowTextureRes = velikost teto textury */

	void renderGrid2D( const Point_3<double> &from, const Point_3<double> &to, const CRgbw &color, double lineOffset, float rot[3], float width =1.0 );

};

#endif