#ifndef MAINFRAME_WIDGET_H
#define MAINFRAME_WIDGET_H

#include <QtGui>
#include "ui_mainframeWidget.h"
#include "softProj\DetailsWidget\ParamDetailsWidget.h"
#include "softProj\clientServer\structs.h"
#include "softProj\Main\INotifyUpdate.h"

///Manages and displays Mainnframe data.
class MainframeWidget : public NotifyWidget {
	Q_OBJECT

private:
	Ui::MainframeWidget ui_;
	QString consumptionUnit_;
public:
	MainframeWidget(QWidget * parent) : NotifyWidget(parent) {
		ui_.setupUi(this);

		ui_.mainframeSection->setName(L"Hlavn pota");

		ui_.prediction->setName(L"Predikce");
		ui_.prediction->setDescription(
			L"Predikce ovlivuje zejmna manvrovatelnost lod a pesnost zbran, zlepuje innost senzor a zvyuje navigan a pohybov monosti.\n\n"
			L"Predikce by se dala pirovnat k vkonnmu softwaru i instrukn sad pota dnen doby.");

		ui_.bionodes->setName(L"Bio-uzly");
		ui_.bionodes->setDescription(
			L"Bio-uzly zlepuj schopnost pota kontrolovat vce zkladen a lod. Tento parametr limituje, kolik zkladen i lod me hr vlastnit.\n\n"
			L"Bio-uzly by se daly pirovnat k operan pamti pota dnen doby");

		ui_.timeReusability->setName(L"Znovupouitelnost\nasu");
		ui_.timeReusability->setDescription(
			L"Znovupouitelnost asu zlepuje pedevm fungovn energetickch systm (zbran, tt, a dalch) a vdeckch laborato.\n\n"
			L"Znovupouitelnost asu lze pirovnat k taktovac frekvenci procesor dnen doby.");

		ui_.descriptionText->setText(QString::fromUtf16(L"Funkc genertoru tt je zajitn deflektorovch energetickch tt kolem lodi. \n\ntty vrazn chrn tak lo ped toky neptel"));

		ui_.consumptionButton->setText(QString::fromUtf16(L"Spoteba energie"));
		ui_.damageStatusLabel->setText(QString::fromUtf16(L"Stav zazen"));
		ui_.damageStatusSlider->setUnit(L"%");
		ui_.damageStatusSlider->setLimits(0, 100);
		ui_.damageStatusSlider->setEnabled(false);

		consumptionUnit_ = " GW";
	}

	void setState(mainframe_status & state) {
		this->rememberUpdateTime();

		ui_.prediction->setCount(state.actualPrediction);	
		ui_.bionodes->setCount(state.actualBioNodes);			
		ui_.timeReusability->setCount(state.actualTimeReusability);		

		ui_.consumptionValue->setText(Settings::instance().formatNumber((unsigned long long) (state.actualConsumption * 100)) + consumptionUnit_);	
		ui_.damageStatusSlider->setValue(state.status * 100);
	} /**< Sets and displayes mainframe params. */

	void notifyUpdate() {}
};

#endif