#ifndef HR_SENSORS_WIDGET
#define HR_SENSORS_WIDGET

#include <QtGui>
#include "ui_sensorsWidget.h"
#include "softProj\clientServer\structs.h"
#include "softProj\Main\INotifyUpdate.h"

///This widget is used for shield managment.
class SensorsWidget : public NotifyWidget {
	Q_OBJECT

private:
	Ui::SensorsWidget ui_;

	QString rangeUnit_;
	QString weightUnit_;
	QString consumptionUnit_;

	sensors_data hrSensorsState_;
	sensors_data lrSensorsState_;

	QString availableButtonStyle_;
	QString unavailableButtonStyle_;

	QString availableDamageStyle_;
	QString unavailableDamageStyle_;
signals:
	/** Signals that user wants to unmount item
	@param patternName Name of pattern for device to unmount
	*/
	void unmountSignal(const std::string & patternName);

	/** Signals that widget wants to show dialog */
	void showDialogSignal();

	/** Signals that widget wants to hide dialog */
	void hideDialogSignal();
private slots:
	/** Slot informing that user clicked button for unmounting */
	void unmountHRSensorsButtonClickedSlot(bool checked);

	/** Slot informing that user clicked button for unmounting */
	void unmountLRSensorsButtonClickedSlot(bool checked);
public:
	SensorsWidget(QWidget * parent);
	~SensorsWidget();

	void setState(const sensors_data & sensors, const sensors_data & probe);
	void setHrSensorsAvailable(bool available);
	void setLRSensorsAvailable(bool available);
	void notifyUpdate();
};

#endif