#include "coordConvertor.h"
#include "illumination\tricol.h"
#include "datetime.h"

#ifndef GAME_SETTINGS_H
#define GAME_SETTINGS_H

class GameConstants
{
public:
	static unsigned int FONT_TEXTURE_ID;

	static const int MAX_SIMULATION_SKIP_COUNT;
	static const int MAX_RENDER_SKIP_COUNT;
	static const int MAX_UPDATE_SHIPS_SKIP_COUNT;
	static const float SERVER_TIME_SPEED_UP; 
	static const float MEASURING_MACRO_SCALE;
	static const float MEASURING_MICRO_SCALE;
	static const float MAX_TOLERABLE_POSTION_DISTANCE_DIFFERENCE_CORRECTOR;
	static const float ATTENUATION_FACTOR_CORRECTOR;
	static CoordConvertor MICRO_COORD_CONVERTOR;
	static CoordConvertor MACRO_COORD_CONVERTOR;

	//predefined colors
	static const CRgbw SCIFI_GREEN_DARK;
	static const CRgbw SCIFI_GREEN_BRIGHT;
	static const CRgbw SCIFI_MAGNETA;
	static const CRgbw SCIFI_RED;

	static const float 	LINE_WIDTH;
	static const unsigned int CIRCLE_SEGMENT_COUNT;
};


#endif