// ################################
// ##  Specialni listy urcene    ##
// ##   pro praci s databazi     ##
// ################################

#pragma once
#ifndef DBLISTS_H
#define DBLISTS_H

#include "common.h"

#include <deque>
#include <list> 

// ################################

template<typename T> class dbdeque : public std :: deque<T>
{
private:
    bool modified_;
public:
    bool is_modified() { return modified_;  };
    void clear_flag()  { modified_ = false; };

    // --------------------------------

    dbdeque& operator=(const dbdeque& _Right)
    {
        modified_ = true;
        std :: deque<T> :: operator =(_Right);
        return *this;
    }

    // --------------------------------

    typedef T _Ty;

    // --------------------------------

    void push_front(const _Ty& _Val)
    {
        modified_ = true;
        std :: deque<T> :: push_front(_Val);
    }

    // --------------------------------

    void pop_front()
    {
        modified_ = true;
        std :: deque<T> :: pop_front();
    }

    // --------------------------------

    void push_back(const _Ty& _Val)
    {
        modified_ = true;
        std :: deque<T> :: push_back(_Val);
    }

    // --------------------------------

    void pop_back()
    {
        modified_ = true;
        std :: deque<T> :: pop_back();
    }

    // --------------------------------

    iterator erase(iterator _First, iterator _Last)
    {
        modified_ = true;
        return std :: deque<T> :: erase(_First, _Last);
    }

    // --------------------------------

    void clear()
    {
        modified_ = true;
        std :: deque<T> :: clear();
    }

    // --------------------------------

    void remove(const _Ty& _Val)
    {
        modified_ = true;
        std :: deque<T> :: remove(_Val);
    }

    // --------------------------------

    iterator erase(iterator _Where)
    {
        modified_ = true;
        return std :: deque<T> :: erase(_Where);
    }

    // --------------------------------

    reference operator[](size_type _Pos)
    {
        modified_ = true;
        return std :: deque<T> :: operator [](_Pos);
    }

    // --------------------------------

    reference front()
    {
        modified_ = true;
        return std :: deque<T> :: front();
    }

    // --------------------------------

    reference back()
    {
        modified_ = true;
        return std :: deque<T> :: back();
    }

    // --------------------------------
};

// ################################
// ################################

template<typename T> class dblist : public std :: list<T>
{
private:
    bool modified_;
public:
    bool is_modified() { return modified_;  };
    void clear_flag()  { modified_ = false; };

    // --------------------------------

    dblist& operator=(const dblist& _Right)
    {
        modified_ = true;
        std :: list<T> :: operator =(_Right);
        return *this;
    }

    // --------------------------------

    typedef T _Ty;

    // --------------------------------

    void push_front(const _Ty& _Val)
    {
        modified_ = true;
        std :: list<T> :: push_front(_Val);
    }

    // --------------------------------

    void pop_front()
    {
        modified_ = true;
        std :: list<T> :: pop_front();
    }

    // --------------------------------

    void push_back(const _Ty& _Val)
    {
        modified_ = true;
        std :: list<T> :: push_back(_Val);
    }

    // --------------------------------

    void pop_back()
    {
        modified_ = true;
        std :: list<T> :: pop_back();
    }

    // --------------------------------

    iterator erase(iterator _First, iterator _Last)
    {
        modified_ = true;
        return std :: list<T> :: erase(_First, _Last);
    }

    // --------------------------------

    void clear()
    {
        modified_ = true;
        std :: list<T> :: clear();
    }

    // --------------------------------

    void remove(const _Ty& _Val)
    {
        modified_ = true;
        std :: list<T> :: remove(_Val);
    }

    // --------------------------------

    iterator erase(iterator _Where)
    {
        modified_ = true;
        return std :: list<T> :: erase(_Where);
    }

    // --------------------------------
};

// ################################

#endif